<?php
/*
 * (c) NETZKOLLEKTIV GmbH <kontakt@netzkollektiv.com>
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

\Magento\Framework\Component\ComponentRegistrar::register(
    \Magento\Framework\Component\ComponentRegistrar::MODULE,
    'Netzkollektiv_EasyCredit',
    __DIR__
);

class NetzkollektivEasyCreditApiAutoloader
{
    public function __construct()
    {
        spl_autoload_register([$this,'registerAutoload']);
    }

    public function registerAutoload($class)
    {
        $prefix   =  'Netzkollektiv\\EasyCreditApi\\';
        $base_dir = __DIR__ . '/Library/';
        $len = strlen($prefix);

        if (strncmp($prefix, $class, $len) !== 0) {
            return;
        }
        $relative_class = substr($class, $len);
        $file = $base_dir . str_replace('\\', '/', $relative_class) . '.php';
        if (file_exists($file)) {
            require $file;
        }
    }
}
new NetzkollektivEasyCreditApiAutoloader();
